{***************************************************************************
*  You can find the license in the docs directory
*
*  Unicode Reminder メモ
***************************************************************************}

	<div class="content2-pagetitle">
		<img src="resource2/{$opt.template.style}/images/misc/32x32-tools.png" style="align: left; margin-right: 10px;" width="32" height="32" alt="" />Information on cache descriptions
	</div>
	<div id="cachedescinfo" class="content-txtbox-noshade" style="padding-right: 25px;">
	
		<p><b>Name:</b> Please choose a comprehensible name, which describes the cache or the location. Use different names for different caches.</p>

		<p><b id="cachetype">Cache type:</b> There are several ways to design a cache:
			<table  class="table cachedesctable">
				<tr>
					<td valign="top" style="padding-top:5px"><img src="resource2/ocstyle/images/cacheicon/traditional.gif" width="32" border="0" height="32" align="left" alt="Traditional Cache" title="Traditional Cache" /></td>
					<td><p><span class="subtitle">Traditional Cache</span>: The coordinates point directly to the cache stash. The cache is a container with a logbook, and no puzzles or quests must be done to find and open it.</p>
					</td>
				</tr>
				<tr>
					<td valign="top" style="padding-top:5px"><img src="resource2/ocstyle/images/cacheicon/drivein.gif" width="32" border="0" height="32" align="left" alt="Drive-In" title="Drive-In" /></td>
					<td><p><span class="subtitle">Drive-In</span>: A traditional cache with a parking area very nearby. No special equipment is needed to find and retrieve the cache.</p></td>
				</tr>
				<tr>
					<td valign="top" style="padding-top:5px"><img src="resource2/ocstyle/images/cacheicon/multi.gif" width="32" border="0" height="32" align="left" alt="Multicache" title="Multicache" /></td>
					<td><p><span class="subtitle">Multicache</span>: The coordinates do not point to the stash, but at the trailhead for seeking the cache. Starting there, the cache can be reached by finding intermediate stages and/or solving puzzles. The solutions must be possible on site.</p></td>
				</tr>
				<tr>
					<td valign="top" style="padding-top:5px"><img src="resource2/ocstyle/images/cacheicon/mystery.gif" width="32" border="0" height="32" align="left" alt="Quiz cache" title="Quiz cache" /></td>
					<td><p><span class="subtitle">Quiz cache</span> (&bdquo;Mystery&ldquo;): A puzzle must be solved to determine the (starting) location of the cache. From there on, it may continue like any other type of cache.</p></td>
				</tr>
				<tr>
					<td valign="top" style="padding-top:5px"><img src="resource2/ocstyle/images/cacheicon/mathe.gif" width="32" border="0" height="32" align="left" alt="Math or physics cache" title="Math or physics cache" /></td>
					<td><p><span class="subtitle">Math or physics cache</span>: To find the cache, you have to solve one or more sophisticated math or physics problems.</p></td>
				</tr>
				<tr>
					<td valign="top" style="padding-top:5px"><img src="resource2/ocstyle/images/cacheicon/moving.gif" width="32" border="0" height="32" align="left" alt="Moving Cache" title="Moving Cache" /></td>
					<td><p><span class="subtitle">Moving Cache</span>: The cache is changing positions. For example, it will be placed at a new location by each finder, who logs the new coordinates and maybe a new quest or puzzle at Opencaching.de. Or the cache is attached to a vehicle, whose coordinates have to be determined.</p></td>
				</tr>
				<tr>
					<td valign="top" style="padding-top:5px"><img src="resource2/ocstyle/images/cacheicon/virtual.gif" width="32" border="0" height="32" align="left" alt="Virtual cache" title="Virtual cache" /></td>
					<td><p><span class="subtitle">Virtual cache</span>: There is no container at the cache site and no logbook. Instead a puzzle or quest must be done on site &ndash; e.g. taking a picture or finding somthing written on a plate &ndash;, before the cache can be logged online.</p></td>
				</tr>
				<tr>
					<td valign="top" style="padding-top:5px"><img src="resource2/ocstyle/images/cacheicon/webcam.gif" width="32" border="0" height="32" align="left" alt="Webcam" title="Webcam" /></td>
					<td><p><span class="subtitle">Webcam cache</span>: A public webcam is utilized to solve the cache. Usually the webcam must be found and a picture of the geocacher be taken. The picture will then be appended to the online log. There is no container or logbook.</p></td>
				</tr>
				<tr>
					<td valign="top" style="padding-top:5px"><img src="resource2/ocstyle/images/cacheicon/event.gif" width="32" border="0" height="32" align="left" alt="Event" title="Event" /></td>
					<td><p><span class="subtitle">Event cache</span>: A meeting of geocachers; anyone may attend.</p></td>
				</tr>
				<tr>
					<td valign="top" style="padding-top:5px"><img src="resource2/ocstyle/images/cacheicon/unknown.gif" width="32" border="0" height="32" align="left" alt="Unknown cache type" title="Unknown cache type" /></td>
					<td><p><span class="subtitle">Unknown cache type</span>: The geocache does not fit any of the types listed above.</p></td>
				</tr>
			</table>
		</p>

		<p><b id="cachesize">Cache size:</b> Size of the cache container; common sizes are:
			<div style="margin-left:12px">
			<ul style="margin-top:0; margin-bottom:0">
				<li><span class="subtitle">nano</span>: tiny, size of a thimble</li>
				<li><span class="subtitle">mikro</span>: e.g. a film canister or a &bdquo;PETling&ldquo;</li>
				<li><span class="subtitle">small</span>: between 100 and 750 ml volume</li>
				<li><span class="subtitle">normal</span>: up to three litres</li>
				<li><span class="subtitle">large</span>: as big as a bucket</li>
				<li><span class="subtitle">very large</span>: everything which is even larger</li>
			</ul>
			</div>
		</p>

		<p><b>Coordinates:</b> The hiding place of the cache, or the first stage, trailhead or parking area of a multicache. If the coordinates have to be found by solving a puzzle: An arbitrary coordinate in the target area, so that the cache may be found on maps and the distance may be estimated.</p>
		<p><b>Country:</b> In which country is the cache location? This information is important especially for near-border caches.</p>

		<p id="difficulty"><b>Rating:</b> Difficulty and Terrain: Difficulty of the tasks necessary to find and unhide the cache / how demanding is the way to the cache?</p>
		<p>Indications for difficulty rating:
			<table  class="table">
				<tr>
					<td></td>
					<td valign="top" style="padding-top:5px;"><img src='./resource2/{$opt.template.style}/images/difficulty/diff-10.gif' border='0' width='19' height='16' hspace='2' /></td>
					<td><b>1</b>: can be found within a few minutes, well suited for beginners</td>
				</tr>
				<tr>
					<td></td>
					<td valign="top" style="padding-top:5px;"><img src='./resource2/{$opt.template.style}/images/difficulty/diff-20.gif' border='0' width='19' height='16' hspace='2' /></td>
					<td><b>2</b>: easy to find for experienced geocaches; may be demanding for beginners</td>
				</tr>
				<tr>
					<td></td>
					<td valign="top" style="padding-top:5px"><img src='./resource2/{$opt.template.style}/images/difficulty/diff-30.gif' border='0' width='19' height='16' hspace='2' /></td>
					<td><b>3</b>: demanding cache &ndash; even experienced cachers may seek for a while or need multiple attempts;  inappropriate for beginners</td> 
				</tr>
				<tr>
					<td></td>
					<td valign="top" style="padding-top:5px"><img src='./resource2/{$opt.template.style}/images/difficulty/diff-40.gif' border='0' width='19' height='16' hspace='2' /></td>
					<td><b>4</b>: an extraordinary challenge or a very difficult puzzle; will need lots of experience and skills or may take more than a day.</td> 
				</tr>
				<tr>
					<td></td>
					<td valign="top" style="padding-top:5px"><img src='./resource2/{$opt.template.style}/images/difficulty/diff-50.gif' border='0' width='19' height='16' hspace='2' /></td>
					<td><b>5</b>: extremely difficult to solve or find</td> 
				</tr>
			</table>
		</p>
		<p>Indications for terrain rating:
			<table  class="table">
				<tr>
					<td></td>
					<td valign="top" style="padding-top:5px;"><img src='./resource2/{$opt.template.style}/images/difficulty/terr-10.gif' border='0' width='19' height='16' hspace='2' /></td>
					<td><b>1</b>: flat area with evenly paved ways, maximum 0.8&nbsp;km (halve a mile) total route; suited for handicapped people</td>
				</tr>
				<tr>
					<td></td>
					<td valign="top" style="padding-top:5px;"><img src='./resource2/{$opt.template.style}/images/difficulty/terr-20.gif' border='0' width='19' height='16' hspace='2' /></td>
					<td><b>2</b>: no major changes in altitude; paved ways, paths, lawns etc.; maxium total route of 3.2&nbsp;km (2&nbsp;miles); suited for small children</td>
				</tr>
				<tr>
					<td></td>
					<td valign="top" style="padding-top:5px"><img src='./resource2/{$opt.template.style}/images/difficulty/terr-30.gif' border='0' width='19' height='16' hspace='2' /></td>
					<td><b>3</b>: pathless or steep area, some undergrow, maximum 16&nbsp;km (10&nbsp;miles) of total route; not suited for small children</td> 
				</tr>
				<tr>
					<td></td>
					<td valign="top" style="padding-top:5px"><img src='./resource2/{$opt.template.style}/images/difficulty/terr-40.gif' border='0' width='19' height='16' hspace='2' /></td>
					<td><b>4</b>: pathless area with dense vegetation, very steep with necessity to use hands, or a route of more than 10 miles</td> 
				</tr>
				<tr>
					<td></td>
					<td valign="top" style="padding-top:5px"><img src='./resource2/{$opt.template.style}/images/difficulty/terr-50.gif' border='0' width='19' height='16' hspace='2' /></td>
					<td><b>5</b>: can only be done with special equipment and skills; finding the cache requires climbing, diving etc.</td> 
				</tr>
			</table>
		</p>

		<p><a name="time"></a><b>Effort:</b> How much time and way is to be expected, beginning at the starting point or parking lot, to find the cache and return to the starting point? Please assume that the geocacher is experienced, but will struggle to solve the one or other puzzle or quest. If you cannot pin down the time needed, keep the default of 0&nbsp;h / 0&nbsp;min and describe the effort. If you estimated the time assuming use of inline skates, a bicycle or car, please mention it in the cache description.</p>

		<p><b>Cache attributes:</b> Use the attributes to specify properties of your cache, which may be selected by the <a href="search.php">search function</a>. Attributes may be estimated and depend on your knowledge of the site (e.g. frequent occurance of ticks). As searcher and finder of a cache, you may tell the owner about the usage and helpfullness of attributes or make suggestions. When describing your caches, please assume normal, dry weather conditions.</p>
		<p><a href="#attributedesc">See below</a> for a complete explanation of cache attributes.</p>

		<p><b>Short description:</b> Try to subsume your cache by a few words!</p>
		<p><b>Description:</b> Enter any information which is needed to find the cache, but avoid spoiling it by telling too much! </p>
		<p><b>Hint:</b> For the case the geocacher has no clue how to find it, give her a final aid to unhide it! </p>
		<p><b>Hidden on:</b> The date when you did hide the cache. If you enter a future date, the cache will be listed as "temporarily not available", and you will have to change the state to "available" when the cache is hidden. For an event cache, enter the planned date of the event.</p>
		<p><a name="logpw"></a><b>Password to log:</b> If specified, every finder has to enter this password when logging online. He will not be able to log "found it" without password. Case does not matter. Be careful when using 0, O, i or j, because these characters may be confused.</p>
		<p><b>Terms of use:</b> Please read our terms of use carefully! We tried hard to make them brief and fair.</p>
		<p><b>Pictures:</b> Pictures may be uploaded after entering and saving the cache listing: Open the listing and click "Edit" at the second-to-top menu. Look for the section "Pictures" and click on "Upload a picture".</p>

		<br id="attributedesc" />
		<div class="content2-container bg-blue02">
			<p class="content-title-noshade-size2" style="margin:0 !important">&nbsp;{t}Cache attributes{/t}</p>
		</div>
		<p>
			{include file="articles_res_attributes.tpl"}
		</p>

</div>
